#!/bin/sh
DOM_LIST=""
DOM_SIDS=""
DOM_BASE=""
SID2XID() {
	SID=$1
	COUNT=0
	for I in `echo $SID | sed -e "s/-/ /g"`
	do
		if [ $COUNT = 0 ]; then
			SID_T0=$I
		elif [ $COUNT = 1 ]; then
			SID_T1=$I
		elif [ $COUNT = 2 ]; then
			SID_T2=$I
		elif [ $COUNT = 3 ]; then
			SID_T3=$I
		elif [ $COUNT = 4 ]; then
			SID_T4=$I
		elif [ $COUNT = 5 ]; then
			SID_T5=$I
		elif [ $COUNT = 6 ]; then
			SID_T6=$I
		elif [ $COUNT = 7 ]; then
			SID_T7=$I
		fi
		RID=$I
		COUNT=$(($COUNT+1))
	done
	if [ "$SID_T0" != "S" -o "$SID_T1" != "1" -o "$SID_T2" != "5" -o "$SID_T3" = "" -o "$SID_T4" = "" -o "$SID_T5" = "" -o "$SID_T6" = "" ]; then
		echo 0 #"not SID"
		return 1
	fi
	DOM_IDBASE=$(($SID_T3*900919))
	DOM_IDX=$(($SID_T4%2))
	DOM_IDX=$(($DOM_IDX*2 + $SID_T5%2))
	DOM_IDX=$(($DOM_IDX*2 + $SID_T6%2))
	DOM_IDX=$(($DOM_IDX*2 + $SID_T4/2%2))
	DOM_IDX=$(($DOM_IDX*2 + $SID_T5/2%2))
	DOM_IDX=$(($DOM_IDX*2 + $SID_T6/2%2))
	DOM_IDX=$(($DOM_IDX*2 + $SID_T4/4%2))
	DOM_IDX=$(($DOM_IDX*2 + $SID_T5/4%2))
	DOM_IDX=$(($DOM_IDX*2 + $SID_T6/4%2))
	DOM_IDX=$(($DOM_IDX*2 + $SID_T4/8%2))
	DOM_IDX=$(($DOM_IDX*2 + $SID_T5/8%2))
	UID_BASE=$(((($DOM_IDX+$DOM_IDBASE)%2047+1)*2097152))
	if [ "$SID_T7" = "" ]; then
		echo $UID_BASE
		return 0
	fi
	RET=$(($UID_BASE+$RID))
	echo $RET
	return 0
}

SID_CHECK_AND_CORRECT() {
	local ID=0
	local UG="UID"
	local J=0
	cat /tmp/syno_tdb_keys.tmp | while read line
	do
		SID=$line
		UG="UID"
		ID=`tdbtool /var/lib/samba/winbindd_idmap.tdb show "$SID\0" | grep UID | cut -d"I" -f2 | cut -d' ' -f2,3 | sed -e "s/ //g"`
		if [ "$ID" = "" ]; then
			UG="GID"
			ID=`tdbtool /var/lib/samba/winbindd_idmap.tdb show "$SID\0" | grep GID | cut -d"I" -f2 | cut -d' ' -f2,3 | sed -e "s/ //g"`
			if [ "$ID" = "" ]; then
				continue
			fi
		fi
		J=1
		for ID_BASE in $DOM_BASE
		do
			if [ $ID -ge $ID_BASE -a $ID -lt $(($ID_BASE + 2097152)) ]; then
				local CRID=$(($ID - $ID_BASE))
				local CSID=`echo $DOM_SIDS | cut -d' ' -f${J}`
				echo "CFT $UG $SID <--> $ID"
				echo "Correct SID should be ${CSID}-${CRID}"
				tdbtool /var/lib/samba/winbindd_idmap.tdb delete "$SID\0"
				tdbtool /var/lib/samba/winbindd_idmap.tdb delete "$UG $ID\0"
				if [ "$UG" = "UID" ]; then
					wbinfo -i "`wbinfo -s ${CSID}-${CRID} | sed 's/ 1$//'`"
				elif [ "$UG" = "GID" ]; then
					wbinfo --group-info="`wbinfo -s ${CSID}-${CRID} | sed 's/ 2$//'`"
				fi
				echo ""
				break
			fi
			J=$(($J+1))
		done
	done

	return 0
}

#wrong domain SID
if [ ! -f "/usr/syno/etc/private/domain_list" ]; then
	echo "No domain list"
	return 1
fi
for DOMAIN in `cat /usr/syno/etc/private/domain_list`
do
	DOMAIN_SID=`wbinfo -D $DOMAIN | grep SID | cut -d':' -f2 | cut -d' ' -f2`
	BASE_ID=`SID2XID $DOMAIN_SID`
	if [ "$DOM_LIST" = "" ]; then
		DOM_LIST=$DOMAIN
		DOM_SIDS=$DOMAIN_SID
		DOM_BASE=$BASE_ID
	else
		DOM_LIST="$DOM_LIST $DOMAIN"
		DOM_SIDS="$DOM_SIDS $DOMAIN_SID"
		DOM_BASE="$DOM_BASE $BASE_ID"
	fi
done

tdbtool /run/samba/gencache.tdb erase
tdbtool /run/samba/gencache_notrans.tdb erase

tdbtool /var/lib/samba/winbindd_idmap.tdb keys | grep "S-1-5" > /tmp/syno_tdb_keys.tmp
for I in $DOM_SIDS
do
	grep -v "$I" /tmp/syno_tdb_keys.tmp > /tmp/syno_tdb_keys.tmp1
	mv /tmp/syno_tdb_keys.tmp1 /tmp/syno_tdb_keys.tmp
done

cat /tmp/syno_tdb_keys.tmp | cut -d':' -f2 | cut -d' ' -f2 > /tmp/syno_tdb_keys.tmp1
mv /tmp/syno_tdb_keys.tmp1 /tmp/syno_tdb_keys.tmp

SID_CHECK_AND_CORRECT

if [ -f "/tmp/syno_tdb_keys.tmp" ]; then
	rm /tmp/syno_tdb_keys.tmp
fi

echo "fix wrong id <--> sid mapping done"

#UID map to GID issue
TMP_FILE="/tmp/idmap.domain.user.list"
synouser --enum domain > ${TMP_FILE}
sed -i '1d' ${TMP_FILE}
sed -i 's/\\/\\\\/g' ${TMP_FILE}
cat ${TMP_FILE} | while read line
do
	SID=`wbinfo -n "$line" | cut -d' ' -f1`
	tdbtool /var/lib/samba/winbindd_idmap.tdb show "${SID}\0" | grep GID
	if [ $? = 0 ]; then
		tdbtool /var/lib/samba/winbindd_idmap.tdb delete "${SID}\0"
		wbinfo -i "$line"
	fi
done
rm ${TMP_FILE}
echo done
