#!/bin/sh
# Copyright (c) 2000-2016 Synology Inc. All rights reserved.


findfile() {
	local pattern=${1}

	echo "... dmesg"
	dmesg | grep "$pattern";
	echo "... /var/log/dmesg"
	grep "$pattern" /var/log/dmesg;
	echo "... /var/log/messages"
	grep "$pattern" /var/log/messages;
	test -f /var/log/messages.1.xz && echo "... /var/log/message.1.xz" && xzcat /var/log/messages.1.xz |grep "$pattern"
	test -f /var/log/messages.2.xz && echo "... /var/log/message.2.xz" && xzcat /var/log/messages.2.xz |grep "$pattern"
	test -f /var/log/messages.3.xz && echo "... /var/log/message.3.xz" && xzcat /var/log/messages.3.xz |grep "$pattern"
}

tune2fsCheckDev() {
	local dev=$1;
	tune2fs -l "$dev" |grep -q "FS Error" && echo "tune2fs -l $dev: FS Error found"
}

tune2fsCheck() {
	echo "... tune2fs"
	local devs="/dev/md0 /dev/sda1 $(cut -d ' ' -f 1 /run/synostorage/volumetab)"
	for i in $devs; do
		tune2fsCheckDev $i
	done
}

echo "====> 1. Find Disk Error <===="
findfile "exception Emask\|status: {\|error: {\|SError: {"
echo ""

echo "====> 2. Find Ext Error <===="
findfile "EXT4-fs .*: error\|EXT4-fs error\|EXT4-fs warning\|read error corrected"
tune2fsCheck
